package fr.doap.jdb.utils.proxies;

import fr.doap.slog.*;

import java.lang.reflect.*;
import java.util.*;

public class ListProxy implements InvocationHandler {
	
	static public <T extends List> T getProxy(T aObject) {
		return (T) Proxy.newProxyInstance(aObject.getClass().getClassLoader(), new Class<?>[]{ List.class }, new ListProxy(aObject));
	}
	
	private ListProxy(List aList) { mList=aList;	}
	
	@Override
	public Object invoke(Object proxy, Method method, Object[] args) throws Throwable {
		if (!mLoaded) {
			mLoaded = true;
			L.i("Loading list values... DONE !");
		} else L.t("Values already loaded");
		return method.invoke(mList, args);
	}
	
	private boolean	mLoaded = false;
	private List	mList;
}
